//
//  CalculatorController.swift
//  calculator
//
//  Created by Илья Лошкарёв on 18.02.17.
//  Copyright © 2017 Илья Лошкарёв. All rights reserved.
//

import UIKit

class CalculatorController: UIViewController {

    @IBOutlet var outputLabel: UILabel!
    
    weak var calculator: Calculator?
    
    let formatter = NumberFormatter()
    let maximumFractionDigits = 5
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        // Обращаемся к созданному калькулятору
        calculator = (UIApplication.shared.delegate as! AppDelegate).calculator
        // Становимся представителем
        calculator?.delegate = self
        // Очищаем состояние калькулятора
        calculator?.reset();
        
        // Число с одной цифрой
        formatter.minimumIntegerDigits = 1
    }
    
    @IBAction func buttonTouched(sender: UIButton)  {
        
        guard let content = sender.titleLabel?.text else {
            print("No text for touched button")
            return
        }
        
        switch content {
            
        case "0"..."9":
            calculator?.addDigit(Int(content)!)
        
        case formatter.decimalSeparator:
            calculator?.addPoint()
        
        case "C":
            if let _ = calculator?.input {
                calculator?.clear();
            } else {
                calculator?.reset();
            }
        
        case "%", "±", "+", "-", "×", "÷":
            calculator?.addOperation(Operation(rawValue:content)!)
            
        case "=":
            calculator?.compute()
            
        default:
            print("Unknown button")
        }
    }
}
